Delaunay Triangulation in OpenCascade

Delaunay Triangulation in
OpenCascade

eryar@163.com

摘要:本文简单介绍了Delaunay三角剖分的基础理论,并运用OpenCascade的三角形剖分算法将边界BRep表示的几何体进行三角离散化后在OpenSceneGraph中展现。 

关键字:Delaunay Triangulation、OpenCascade、OpenSceneGraph 

一、 概述

三角形剖分是平面剖分中的一个重大课题,在数字图像处理、Computer三个维度曲面造型、有限元总计、逆向工程等领域有所普遍应用。由于三角形是平面域中的单纯形,与任何平面图形相比较,其有描述方便、处理大致等特点,很吻合于对复杂区域展开简化处理。因而,无论在测算几何、Computer图形处理、情势识别、曲面逼近,还有半点元网格生成下边有广泛的施用。 

即便如此曲线、曲面等有准儿的方程来表示,可是在在计算机中,只可以用离散的艺术来逼近。如曲线可用直线段来逼近,而曲面可用多边形或三角形来代表。用多边形网格表示曲面是陈设性中常常使用的样式,能够根据使用须求选拔网格的密度。利用三角形面片表示的曲面在微机图形学中也号称三角形网格。用三角网格表示曲面供给缓解多少个难点:三角形的发出、描述、遍历、简化和裁减等,那一个题材都以一个钱打二15个结几何钻探的局面,相关主题素材都足以从中找到答案。下图所示的圆柱和立方体是由OpenCascade生成,使用OpenCascade的算法离散成三角网格后在OpenSceneGraph中显示的功能。 

化学答案 1

Figure 1.1 Shaded Cylinder and Box 

化学答案 2

Figure 1.2 Mesh generated by OpenCascade 

从图中得以观察,平面包车型客车三角网格效能还能够,曲面包车型地铁三角形网格表示只可以是近乎表示,能够由此抓牢网格的密度来增添真实性,但对应渲染的数据量就大了。有人说OpenCascade的来得模块做得不是很好,上述格局则足以只利用OpenCascade的模样模块,再结合OpenSceneGraph来对图片举办展示。 

三个维度数据调换STL格式文件中保留的都以三角面片的数码,STL文件格式是由美利哥3D
System公司支付,已被工产业界认为是当下高速机动成型领域的准标准零件描述文件格式。它对三个维度实体描述的解释具备惟一性。差不多全部的几何样子系统都提供STL文件数据沟通接口。OpenCascade中的数据沟通模块也提供对STL格式的支撑,综上可得三角网格在几何样子系统中的主要性。 

Voronoi图和Delaunay三角剖分的应用领域十分大面积:几何建立模型——用来探求三个维度曲面“好的”三角剖分;有限元分析——用来扭转“好的”有限元网格;地理消息体系——用来开始展览空间领域分析;结晶学——用来规定合金的结构;人类学和考古学——用来分明氏族部落、带头人权威、居住焦点或壁垒等的熏陶范围;天管农学——用来显明恒星和星系的遍布;生物学生态学和林学——用来规定动物植物物的竞争;动物学——分析动物的领地;总结学和数码解析——用来分析计算聚合;机器人学——用来实行运动轨迹规划(在设有障碍物的意况下);情势识别——作为寻觅物体骨架点的工具;生教育学——用来分析毛细作用的天地;气象学——用来打量区域平均降水量;市场学——用来建立城市的商海辐射范围;以及在遥感图像处理、化学、地艺术学、地质学、冶金学、数学等学科的使用等。 

正文只对OpenCascade中的三角剖分举办简易介绍,希望对三角剖分在三个维度几何样子方面风乐趣的情人能够对其深远钻研。水平很单薄,文中不当之处欢迎批评指正、指点,联系邮箱:eryar@163.com。 

二、 Voronoi图

Dirichlet于1850年商量了平面点的邻域难点,Voronoi于1910年将其结果扩张到高维空间。半空间定义Voronoi图:给定平面上n个点集S,S={p一,
p二, …, pn}。定义: 

化学答案 3

PiPj连线的垂直平分面将空间分为两半,V(Pi)表示比任何点更类似Pi的点的轨道是n-一个半平面包车型大巴交,它是1个不多于n-壹条边的凸多边形域,称为关联于Pi的Voronoi多边形或涉嫌于Pi的Voronoi域。如下图所示为涉嫌于P1的Voronoi多边形,它是1个4边形,而n=陆. 

化学答案 4

Figure 二.壹 n=陆时的一种V(p一) 

对于点集S中的每一个点都足以做一个Voronoi多边形,这样的n个Voronoi多边形组成的图称为Voronoi图,记为Vor(S)。如下图所示: 

化学答案 5

Figure 2.2 Voronoi diagram for 10 randomly points (Generated by MATLAB) 

图中的顶点和边分外号字为Voronoi顶点和Voronoi边。显著,|S|=n时,Vor(S)划分平面成n个多边形域,各类多边形域V(Pi)包涵S中的3个点同时只含有S中的1个点,Vor(S)的边是S中某点对的垂直平分线上的一条线条或半直线,从而为该点对所在的五个多边形域所共有。Vor(S)中有个别多边形域是无界的。 

化学答案 6

Figure 2.3 Ten shops in a flat city and their Voronoi cells 

(http://en.wikipedia.org/wiki/Voronoi\_diagram

化学答案 7

Figure 2.4 Voronoi tessellation in a cylinder (Voro++ library:
http://math.lbl.gov/voro++/

Voronoi图有如下性质: 

l n个点的点集S的Voronoi图至多有2n-多少个极点和三n-陆条边; 

l 每种Voronoi点恰好是三条Voronoi边的交点; 

l 设v是Vor(S)的终极,则圆C(v)内不含S的任何点; 

l 点集S中式点心Pi的每3个近年来附近点鲜明V(Pi)的一条边; 

l Voronoi图的直线对偶图是S的一个三角形剖分; 

l
就算Pi,Pj属于S,并且通过Pi,Pj有3个不包罗S中其余点的圆,那么线段PiPj是点集S三角剖分的一条边,反之亦建立。 

3、 Delaunay三角剖分 

一. 二维实数域上的三角形剖分

若是V是2维实数域上的有限点集,边e是由点集中的点作端点构成的封闭线段,E为e的汇集,那么该点集V的三个三角形剖分T=(V,E)是三个平面图: 

l 除了端点,平面图中的边不包罗点集中的任何点; 

l 没有相交边; 

l 平面图中保有的面都以三角面,且独具三角面包车型地铁合集是点集V的凸包。 

2. Delaunay边

尽管E中的一条边(两端点a,b),e知足下列条件,则号称Delaunay边:存在三个圆经过a,b两点,圆内不含有点集V中的任何的点。这一特点又称之为空圆本性。 

三. Delaunay三角剖分

要是点集V的三个三角形剖分T中只包涵Delaunay边,那么该三角剖分称为Delaunay剖分。 

近年来点意思下的Voronoi图的双双图实际上是点集的一种三角剖分,该三角剖分便是Delaunay剖分(表示为DT(S)),当中每一个三角形的外接圆不包含点集中的此外任何点。由此,在社团点集的Voronoi图之后,再作其对偶图,即对每条Voronoi边作通过点集中某两点的垂直平分线,即赚取Delaunay三角剖分。 

化学答案 8

Figure 3.1 Delaunay Triangulation (Generated by MATLAB) 

再看几个图片,加深对Delaunay三角剖分的精晓: 

化学答案 9

Figure 3.2 Delaunay Edge  

化学答案 10

Figure 3.3 Illustrate Delaunay Edge 

化学答案 11

Figure 3.4 Delaunay Edge 

肆. Delaunay三角剖分的性状

l
一九七八年Sibson注脚了在贰维的情事下,在点集的具备三角剖分中,Delaunay三角剖分使得生成的三角的最小角到达最大(max-min
angle)。因为那1特色,对于给定点集的Delaunay三角剖分总是尽只怕防止“瘦长”三角形,自动向等边三角形逼近; 

l 局部优化与完整优化(locally optimal and globally optimal); 

l Delaunay空洞(cavity)与壹些重连(local reconnection); 

  1. 经文的Delaunay三角剖分算法 

当下常用的算法分为二种,有扫描线法(Sweepline)、随机增量法(Incremental)、分治法(Divide
and Conquer)等。 

经文的Delaunay三角剖分算法主要有两类:Bowyer/沃特son算法和部分转换法。 

l
Bowyer/沃特son算法又叫做Delaunay空洞算法或加点法,以Bowyer和Watson算法为代表。从叁个三角形起先,每一次加1个点,有限支撑每一步获得的当下三角形是局地优化的。以大不列颠及苏格兰联合王国Bath大学数学分校Bowyer,格林,Sibson为代表的盘算Dirichlet图的不二秘诀属于加点法,是较早成名的算法之1;以澳国布鲁塞尔赫鲁大学学地球科学系沃特son为代表的空外接球法也属于加点法。加点法算法简明,是当下选择最多的算法,该办法运用了Delaunay空洞性质。Bowyer/沃特son算法的长处是与空间的维数毫无干系,并且算法在促成上比部分调换算法简单。该算法在新点进入到Delaunay网格时,部十一分接球包罗新点的三角形单元不再适合Delaunay属性,则那些三角形单元被删除,变成Delaunay空洞,然后算法将新点与构成空洞的每二个终端相连生成三个新边,依据空球属性能够注明这一个新边都以某个Delaunay的,因而新生成的三角形网格仍是Delaunay的。 

化学答案 12

Figure 3.5 Illustration of 2D Bowyer/Watson algorithm for Delaunay
Triangulation 

l
局地调换法又称之为换边、换面法。当使用部分转变法实现增量式点集的Delaunay三角剖分时,首先定位新加入点所在的三角,然后在网格中进入三个新的连天该三角形顶点与新顶点的边,若该新点位于某条边上,则该边被删除,肆条连接该新点的边被投入。最终,在通过换边方法对该新点的一些区域内的边举行检验和改变,重新维护网格的Delaunay性质。局地调换法的另贰个独到之处是其得以对已存在的三角形网格实行优化,使其更改到为Delaunay三角网格,该格局的欠缺则是当算法扩展到高维空间时变得相比复杂。 

4、 Delaunay三角剖分在OpenCascade的利用

Open卡斯卡特中网格剖分的包重要有BRepMesh、MeshAlgo、MeshVS,在那之中,类MeshAlgo_Delaunay使用算法沃特son来开始展览Delaunay三角剖分。从类StlTransfer中的注释The
triangulation is computed with the Delaunay algorithm implemented in
package
BRepMesh.能够阅览包BRepMesh正是Delaunay三角剖分的切实可行得以达成。使用方法如下: 

BRepMesh::Mesh (aShape, Deflection); 

以此函数首假若用来对拓扑形状实行三角剖分。以下通过将3个圆柱三角剖分为例表达什么将贰个拓扑形状进行三角剖分并将结果开始展览可视化。 

/**
*    Copyright (c) 2013 eryar All Rights Reserved.
*
*        File    : Main.cpp
*        Author  : eryar@163.com
*        Date    : 2013-05-26
*        Version : 0.1
*
*    Description : Use BRepMesh_Delaun class to learn 
*                  Delaunay's triangulation algorithm.
*
*/
// Open Cascade library.
#include <gp_Pnt.hxx>
#include <gp_Pln.hxx>
#include <BRep_Tool.hxx>
#include <TopoDS.hxx>
#include <TopoDS_Edge.hxx>
#include <TopoDS_Wire.hxx>
#include <TopoDS_Face.hxx>
#include <BRepBuilderAPI_MakeEdge.hxx>
#include <BRepBuilderAPI_MakeWire.hxx>
#include <BRepBuilderAPI_MakeFace.hxx>

#include <BRepPrimAPI_MakeBox.hxx>
#include <BRepPrimAPI_MakeCone.hxx>
#include <BRepPrimAPI_MakeCylinder.hxx>
#include <BRepPrimApI_MakeSphere.hxx>

#include <BRepMesh.hxx>
#include <TopExp_Explorer.hxx>
#include <Poly_Triangulation.hxx>
#include <TShort_Array1OfShortReal.hxx>

#pragma comment(lib, "TKernel.lib")
#pragma comment(lib, "TKMath.lib")
#pragma comment(lib, "TKBRep.lib")
#pragma comment(lib, "TKPrim.lib")
#pragma comment(lib, "TKMesh.lib")
#pragma comment(lib, "TKTopAlgo.lib")

// OpenSceneGraph library.
#include <osgDB/ReadFile>
#include <osgViewer/Viewer>
#include <osgViewer/ViewerEventHandlers>
#include <osgGA/StateSetManipulator>

#pragma comment(lib, "osgd.lib")
#pragma comment(lib, "osgDbd.lib")
#pragma comment(lib, "osgGAd.lib")
#pragma comment(lib, "osgViewerd.lib")

osg::Node* BuildShapeMesh(const TopoDS_Shape& aShape)
{
    osg::ref_ptr<osg::Group> root = new osg::Group();
    osg::ref_ptr<osg::Geode> geode = new osg::Geode();
    osg::ref_ptr<osg::Geometry> triGeom = new osg::Geometry();
    osg::ref_ptr<osg::Vec3Array> vertices = new osg::Vec3Array();
    osg::ref_ptr<osg::Vec3Array> normals = new osg::Vec3Array();

    BRepMesh::Mesh(aShape, 1);

    TopExp_Explorer faceExplorer;

    for (faceExplorer.Init(aShape, TopAbs_FACE); faceExplorer.More(); faceExplorer.Next())
    {
        TopLoc_Location loc;
        TopoDS_Face aFace = TopoDS::Face(faceExplorer.Current());

        Handle_Poly_Triangulation triFace = BRep_Tool::Triangulation(aFace, loc);
        Standard_Integer nTriangles = triFace->NbTriangles();

        gp_Pnt vertex1;
        gp_Pnt vertex2;
        gp_Pnt vertex3;

        Standard_Integer nVertexIndex1 = 0;
        Standard_Integer nVertexIndex2 = 0;
        Standard_Integer nVertexIndex3 = 0;

        TColgp_Array1OfPnt nodes(1, triFace->NbNodes());
        Poly_Array1OfTriangle triangles(1, triFace->NbTriangles());

        nodes = triFace->Nodes();
        triangles = triFace->Triangles();       

        for (Standard_Integer i = 1; i <= nTriangles; i++)
        {
            Poly_Triangle aTriangle = triangles.Value(i);

            aTriangle.Get(nVertexIndex1, nVertexIndex2, nVertexIndex3);

            vertex1 = nodes.Value(nVertexIndex1);
            vertex2 = nodes.Value(nVertexIndex2);
            vertex3 = nodes.Value(nVertexIndex3);

            gp_XYZ vector12(vertex2.XYZ() - vertex1.XYZ());
            gp_XYZ vector13(vertex3.XYZ() - vertex1.XYZ());
            gp_XYZ normal = vector12.Crossed(vector13);
            Standard_Real rModulus = normal.Modulus();

            if (rModulus > gp::Resolution())
            {
                normal.Normalize();
            }
            else
            {
                normal.SetCoord(0., 0., 0.);
            }

            vertices->push_back(osg::Vec3(vertex1.X(), vertex1.Y(), vertex1.Z()));
            vertices->push_back(osg::Vec3(vertex2.X(), vertex2.Y(), vertex2.Z()));
            vertices->push_back(osg::Vec3(vertex3.X(), vertex3.Y(), vertex3.Z()));

            normals->push_back(osg::Vec3(normal.X(), normal.Y(), normal.Z()));
        }    
    }

    triGeom->setVertexArray(vertices.get());
    triGeom->addPrimitiveSet(new osg::DrawArrays(osg::PrimitiveSet::TRIANGLES, 0, vertices->size()));

    triGeom->setNormalArray(normals);
    triGeom->setNormalBinding(osg::Geometry::BIND_PER_PRIMITIVE);

    geode->addDrawable(triGeom);

    root->addChild(geode);

    return root.release();
}

int main(int argc, char* argv[])
{
    osgViewer::Viewer myViewer;
    osg::ref_ptr<osg::Group> root = new osg::Group();

    root->addChild(BuildShapeMesh(BRepPrimAPI_MakeCylinder(.6, 1)));

    myViewer.setSceneData(root);

    myViewer.addEventHandler(new osgGA::StateSetManipulator(myViewer.getCamera()->getOrCreateStateSet()));
    myViewer.addEventHandler(new osgViewer::StatsHandler);
    myViewer.addEventHandler(new osgViewer::WindowSizeHandler);

    return myViewer.run();
}

结果如下图所示: 

化学答案 13

Figure 4.1 Cylinder mesh generated by BRepMesh::Mesh 

BRepMesh::Mesh是由此包装的,便于对拓扑形状举办三角剖分。以下通过贰个简约的例子来证实直接利用BRepMesh_Delaun的方法: 

/**
*    Copyright (c) 2013 eryar All Rights Reserved.
*
*        File    : Main.cpp
*        Author  : eryar@163.com
*        Date    : 2013-05-26
*        Version : 0.1
*
*    Description : Use BRepMesh_Delaun class to learn 
*                  Delaunay's triangulation algorithm.
*
*/

#include <BRepMesh_Edge.hxx>
#include <BRepMesh_Delaun.hxx>
#include <BRepMesh_Array1OfVertexOfDelaun.hxx>
#include <TColStd_MapIteratorOfMapOfInteger.hxx>

#pragma comment(lib, "TKernel.lib")
#pragma comment(lib, "TKMesh.lib")

int main(int argc, char* argv[])
{
    BRepMesh_Array1OfVertexOfDelaun vertices(1, 4);

    vertices.SetValue(1, BRepMesh_Vertex(0, 0, MeshDS_Free));
    vertices.SetValue(2, BRepMesh_Vertex(1, 0, MeshDS_Free));
    vertices.SetValue(3, BRepMesh_Vertex(1, 1, MeshDS_Free));
    vertices.SetValue(4, BRepMesh_Vertex(0, 1, MeshDS_Free));

    BRepMesh_Delaun triangulation(vertices);
    //triangulation.AddVertex(BRepMesh_Vertex(0.5, 0.5, MeshDS_OnSurface));
    Handle_BRepMesh_DataStructureOfDelaun meshData = triangulation.Result();

    std::cout<<"Iterate Mesh Triangles:"<<std::endl;

    MeshDS_MapOfInteger::Iterator triDom;
    for (triDom.Initialize(meshData->ElemOfDomain()); triDom.More(); triDom.Next())
    {
        Standard_Integer triId = triDom.Key();
        const BRepMesh_Triangle& curTri = meshData->GetElement(triId);

        Standard_Integer vertexIndex1 = 0;
        Standard_Integer vertexIndex2 = 0;
        Standard_Integer vertexIndex3 = 0;

        Standard_Integer edgeIndex1 = 0;
        Standard_Integer edgeIndex2 = 0;
        Standard_Integer edgeIndex3 = 0;

        Standard_Boolean o1 = Standard_False;
        Standard_Boolean o2 = Standard_False;
        Standard_Boolean o3 = Standard_False;

        curTri.Edges(edgeIndex1, edgeIndex2, edgeIndex3, o1, o2, o3);

        const BRepMesh_Edge& edge1 = meshData->GetLink(edgeIndex1);
        const BRepMesh_Edge& edge2 = meshData->GetLink(edgeIndex2);
        const BRepMesh_Edge& edge3 = meshData->GetLink(edgeIndex3);

        vertexIndex1 = (o1? edge1.FirstNode(): edge1.LastNode());
        vertexIndex2 = (o1? edge1.LastNode() : edge1.FirstNode());
        vertexIndex3 = (o2? edge2.LastNode() : edge2.FirstNode());

        const BRepMesh_Vertex& vertex1 = meshData->GetNode(vertexIndex1);
        const BRepMesh_Vertex& vertex2 = meshData->GetNode(vertexIndex2);
        const BRepMesh_Vertex& vertex3 = meshData->GetNode(vertexIndex3);

        const gp_XY& p1 = vertex1.Coord();
        const gp_XY& p2 = vertex2.Coord();
        const gp_XY& p3 = vertex3.Coord();

        std::cout<<"--------"<<std::endl;
        std::cout<<p1.X()<<" , "<<p1.Y()<<std::endl;
        std::cout<<p2.X()<<" , "<<p2.Y()<<std::endl;
        std::cout<<p3.X()<<" , "<<p3.Y()<<std::endl;
        std::cout<<"========"<<std::endl;
    }

    return 0;
}

上述顺序是以2个正方形为例,使用BRepMesh_Delaun三角剖分的结果为三个三角,如下所示: 

Iterate Mesh Triangles: 
——– 
1 , 1 
0 , 0 
化学答案,1 , 0 
======== 
——– 
1 , 1 
0 , 1 
0 , 0 
======== 

 以上结果都以二维空间上的,三个维度空间中的使用办法能够参考类:BRepMesh_法斯特DiscretFace。这么些类表达了什么样将2个面举办网格划分。 

五、 结论

Delaunay三角剖分理论在三个维度几何样子中依旧相比关键的,通过对造型的三角剖分,不仅能够对其开始展览可视化,还有利于对造型做特别的处理,如消隐、光照处理等。通过对OpenCascade中三角剖分算法的使用,以越来越驾驭三角剖分理论运用及其算法落成。 

六、 参考资料

  1. 周培德. 总括几何—算法设计与分析. 武大高校出版社, 2011 

  2. 李海生. Delaunay三角剖分理论及可视化调查探究. 瓦尔帕莱索外国语大学出版社,
    20十 

  3. 何援军. Computer图形学. 机械工业出版社, 2010 

  4. 周元峰, 孙峰, 王文平, 汪嘉业, 张彩明.
    基于局地修复的移位多少点Delaunay三角化快捷更新方法.
    计算机帮忙设计与图片学学报, 2011, 1二: 200陆-101贰 

  5. http://en.wikipedia.org/wiki/Voronoi_diagram

 

PDF Version: Delaunay Triangulation in
OpenCascade

admin

网站地图xml地图